function H = arnoldi(A,v1)

n = max(size(A));

H = zeros(n,n);
V = zeros(n,n);
V(:,1) = v1/norm(v1);
for j=1:n-1
    for i=1:j
        H(i,j) = V(:,j)'*A'*V(:,i);
    end
    w = A*V(:,j) - V(:,1:j)*H(1:j,j);
    H(j+1,j) = norm(w);
    V(:,j+1) = w/H(j+1,j);
end
